/*!
 * quasar-ui-json-api-viewer v2.0.0-alpha.2
 * (c) 2021 Jeff Galbraith <jeff@quasar.dev>
 * Released under the MIT License.
 */
import{defineComponent,h,computed,ref,reactive,watch,onMounted}from"vue";import{QBadge,QList,QItem,Notify,ClosePopup,useQuasar,extend,QCard,QToolbar,QToolbarTitle,QSpace,QInput,QIcon,QMenu,QCheckbox,QSeparator,QTabs,QTab,QTabPanels,QTabPanel}from"quasar";import"prismjs";const NAME_PROP_COLOR=["bg-orange-8","bg-accent","bg-secondary","bg-warning"];var JsonApiItem=defineComponent({name:"JsonApiItem",props:{name:{type:String,required:!0},type:{type:String,default:"props"},json:{type:Object,required:!0},deprecatedColor:{type:String,default:"yellow-8"},deprecatedBackground:{type:String,default:"red-8"},removedColor:{type:String,default:"yellow-8"},removedBackground:{type:String,default:"red-8"}},setup(e,{slots:o}){function n(e,o){if(""===o?o="js":"vue"!==o&&"html"!==o||(o="html"),void 0!==Prism.languages[o]){const n=Prism.highlight(e,Prism.languages[o],o);return'<pre class="q-markdown--code">'+`<code class="q-markdown--code__inner language-${o}">${n}</code></pre>\n`}return""}function t(e,o){let n;return n=" [",o.returns?n+=o.returns.type:n+="void 0",n+="] ",void 0===o.params?n+=e+" ()":n+=e+" ("+Object.keys(o.params).join(", ")+")",n}function a(){let o="@"+e.name+" => function";return void 0===e.json.params?o+" ()":(o+=" ("+Object.keys(e.json.params).join(", ")+")",o)}function r(o,n,a=0){return"Function"===n.type&&(o=t(o,n)),h("div",{class:"component-api__row component-api__row--bordered row"},[k(o,NAME_PROP_COLOR[a]),j(n),void 0!==e.json.removedIn&&y(n),void 0===e.json.removedIn&&void 0!==e.json.deprecated&&g(n),void 0===e.json.removedIn&&void 0===e.json.deprecated&&w(n),f(n),v(n),_(n),b(n),m(n),p(n),u(n),i(n,a+1),s(n,a+1),l(n,a+1),c(n,a+1)])}function i(e,o=0){if(void 0===e.params)return"";const n=Object.keys(e.params);return h("div",{class:"component-api__row--item full-width"},[h("div",{class:"component-api__row--label"},"Parameter"+(Object.keys(e.params).length>1?"s":"")),h("div",{},[n.map(n=>r(n,e.params[n],o))])])}function s(e,o=0){if(void 0===e.definition)return"";const n=Object.keys(e.definition);return h("div",{class:"component-api__row--item full-width"},[h("div",{class:"component-api__row--label"},"Definition"+(Object.keys(e.definition).length>1?"s":"")),h("div",{},[n.map(n=>r(n,e.definition[n],o))])])}function l(e,o=0){if(void 0===e.scope)return"";const n=Object.keys(e.scope);return h("div",{class:"component-api__row--item full-width"},[h("div",{class:"component-api__row--label"},"Scope"),h("div",{},[n.map(n=>r(n,e.scope[n],o))])])}function c(e,o=0){return void 0===e.returns?"":h("div",{class:"component-api__row--item full-width"},[h("div",{class:"component-api__row--label"},"Returns"),h("div",{},[null===e.returns&&"null",null!==e.returns&&r(void 0,e.returns,o)])])}function p(e){return void 0===e.values||e.values.length<=0?"":h("div",{class:"component-api__row--item col-auto"},[h("div",{class:"component-api__row--label"},"Value"+(e.values.length>1?"s":"")),h("div",{class:"component-api__row--values"},e.values.join(", "))])}function d(e){const o=n(e,"js");return h("div",{class:"component-api__row--example",innerHtml:o})}function u(e){return void 0===e.examples||e.examples.length<=0?"":h("div",{class:"component-api__row--item col-auto"},[h("div",{class:"component-api__row--label"},"Example"+(e.examples.length>1?"s":"")),h("div",{class:"component-api__row--value"},[e.examples.map((e,o)=>d(e))])])}function m(e){if(void 0===e.desc)return;const o=n(e.desc,"js");return h("div",{class:"component-api__row--item full-width"},[h("div",{class:"component-api__row--label"},"Description"),h("div",{class:"component-api__row--value"},[h("div",{innerHtml:o})])])}function v(e){return void 0===e.sync?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},[h("div",{class:"component-api__row--label"},"Sync"),h("div",{class:"component-api__row--value"},[h("div",e.sync)])])}function f(e){return void 0===e.required?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},[h("div",{class:"component-api__row--label"},"Required"),h("div",{class:"component-api__row--value"},[h("div",e.required)])])}function b(e){return void 0===e.applicable?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},[h("div",{class:"component-api__row--label"},"Applicable"),h("div",{class:"component-api__row--value"},[h("div",e.applicable.join(", "))])])}function _(e){return void 0===e.default?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},[h("div",{class:"component-api__row--label"},"Default"),h("div",{class:"component-api__row--value"},[h("div",e.default)])])}function y(o){return void 0===o.removedIn?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},[h("div",{class:"component-api__row--label"},[h("span",{class:"rounded-borders text-"+e.removedColor+" bg-"+e.removedBackground},"Removed in")]),h("div",{class:"component-api__row--value"},[h("div",[h("span",{class:"rounded-borders text-"+e.deprecatedColor+" bg-"+e.deprecatedBackground},o.removedIn)])])])}function g(o){return void 0===o.deprecated?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},[h("div",{class:"component-api__row--label"},[h("span",{class:"rounded-borders text-"+e.deprecatedColor+" bg-"+e.deprecatedBackground},"Deprecated")]),h("div",{class:"component-api__row--value"},[h("span",{class:"rounded-borders text-"+e.deprecatedColor+" bg-"+e.deprecatedBackground},o.deprecated)])])}function w(e){return void 0===e.addedIn?"":h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},[h("div",{class:"component-api__row--label"},"Added in"),h("div",{class:"component-api__row--value"},[h("div",e.addedIn)])])}function j(e){if(void 0===e.type)return"";const o=Array.isArray(e.type)?e.type.join(" | "):e.type;return h("div",{class:"component-api__row--item col-xs-12 col-sm-4"},[h("div",{class:"component-api__row--label"},"Type"),h("div",{class:"component-api__row--value"},[h("div",o)])])}function k(e,o){return void 0===e?"":h("div",{class:"component-api__row--item col-grow"},[h("div",{class:"component-api__row--label"},"Name"),h("div",{class:"component-api__row--value"},[h(QBadge,{class:`property-name ${o}`},e)])])}function x(){let o=e.name;"methods"===e.type?o=t(o,e.json):"events"===e.type&&(o=a(o,e.json));const n=0;return h("div",{class:"row full-width"},[k(o,NAME_PROP_COLOR[n]),j(e.json),void 0===e.json.removedIn&&g(e.json),void 0===e.json.deprecated&&w(e.json),y(e.json),f(e.json),v(e.json),_(e.json),b(e.json),m(e.json),p(e.json),u(e.json),i(e.json,n+1),s(e.json,n+1),l(e.json,n+1),c(e.json,n+1)])}function C(){return x()}return()=>C()}}),JsonApiList=defineComponent({name:"JsonApiList",props:{name:{type:String,required:!0},json:{type:Object,required:!0}},setup(e){const o=computed(()=>{return Object.keys(e.json)});function n(){return[...o.value.map(o=>h(QItem,{key:e.name+"-"+o,class:"component-api__list-item"},[h(JsonApiItem,{name:o,type:e.name,json:e.json[o]})]))]}function t(){const o=0!==Object.keys(e.json).length?n():h("div",{staticClass:"q-pa-md text-grey-7"},["No matching entries found. Please refine the filter."]);return h(QList,{class:"component-api__list",separator:!0},[o])}function a(){return t()}return()=>a()}});function copyToClipboard(e){const o=document.createElement("textarea");o.className="fixed-top",o.value=e,document.body.appendChild(o),o.focus(),o.select(),document.execCommand("copy"),document.body.removeChild(o)}function copyHeading(e){const o=window.location.origin+window.location.pathname+"#"+e,n=document.getElementById(e);n&&(n.id=""),"replaceState"in history?history.replaceState(history.state,"",`${location.pathname}#${e}`):window.location.hash="#"+e,n&&setTimeout(()=>{n.id=e},300),copyToClipboard(o),Notify.create({message:"Anchor has been copied to clipboard.",position:"top",color:"white",textColor:"primary",actions:[{icon:"cancel",color:"red-8",dense:!0,round:!0}],timeout:2e3})}const specialRE=/[\s·/_\\,:;\.\(\)\[\]]+/g,andRE=/&/g,nonWordRE=/[^\w-]+/g,multipleDashRE=/--+/g;function slugify(e){return String(e).toLowerCase().replace(specialRE,"-").replace(andRE,"-and-").replace(nonWordRE,"").replace(multipleDashRE,"-")}var version$1="2.0.0-alpha.2",Component=defineComponent({name:"JsonApiViewer",directives:{ClosePopup:ClosePopup},props:{title:{type:String,required:!0},json:{type:Object,required:!0},type:{type:String,default:"Vue Component"},startingTab:String,startingInnerTab:String,noFooter:Boolean},setup(e,{slots:o}){const n=useQuasar(),t=ref(!1),a=ref("props"),r=ref("model"),i=ref(null),s=ref(null),l=ref([]),c=reactive({}),p=reactive({}),d=reactive({}),u=ref("lightblue"),m=ref("light-blue-2"),v=ref(!1),f=ref(!1),b=ref(null),_=computed(()=>slugify(e.title));function y(o){if(void 0===o)return void(t.value=!0);const n=extend(!0,{},o);if(void 0!==n.type&&delete n.type,n.meta&&delete n.meta,C(),void 0!==n.props){const o=Object.keys(n.props).sort();for(let a=0;a<o.length;++a){const t=o[a],r=n.props[t];if(void 0===r.deprecated||!0===e.showDeprecated)if(void 0===r.removedIn||!0===e.showRemoved)if(void 0===d[r.category]&&(d[r.category]={}),k(t))d[r.category][t]=r;else{const e=w(r);Object.keys(e).length>0?d[r.category][t]=e:delete n.props[t]}else delete n.props[t];else delete n.props[t]}Object.assign(p,{});const t=Object.keys(d);for(let e=0;e<t.length;++e){const o=t[e];p[o]=Object.keys(d[o]).length}}g(n);const a=Object.keys(n);for(let e=0;e<a.length;++e){const o=a[e];l.value[o]=Object.keys(n[o]).length}i.value=n,t.value=!0}function g(o){const n=Object.keys(o);for(let t=0;t<n.length;++t){const a=n[t];if("props"!==a){const n=Object.keys(o[a]);for(let t=0;t<n.length;++t){const r=n[t],i=o[a][r];if(void 0!==i.deprecated&&!0!==e.showDeprecated&&delete o[a][r],void 0!==i.removedIn&&!0!==e.showRemoved)delete o[a][r];else if(!0!==k(r)){const e=w(i);0===Object.keys(e).length&&delete o[a][r]}}}}}function w(e){if(null===s.value)return e;let o=!1;const n=Object.keys(e);for(let t=0;t<n.length;++t){const a=e[n[t]],r=Object.prototype.toString.call(a);if("[object Array]"===r){if(x(a)){o=!0;break}}else if(("[object String]"===r||"[object Number]"===r)&&j(a)){o=!0;break}}return!0!==o?{}:e}function j(e){if(e&&s.value)return String(e).toLowerCase().indexOf(s.value.toLowerCase())>=0}function k(e){return j(e)}function x(e){for(let o=0;o<e.length;++o)if(!0===j(e[o]))return!0;return!1}function C(){Object.assign(d,{}),Object.assign(p,{}),Object.assign(c,{}),l.value=[]}function Q(){null!==s.value&&(s.value=null),b.value.focus()}function O(){return h(QToolbarTitle,{class:!0!==e.noAnchor?"example-title":"",onClick:copyHeading},{default:()=>h("span",{class:"ellipsis"},e.title)})}function I(){return h(QInput,{ref:b,class:"q-mx-sm",style:{minWidth:"150px"},placeholder:"Filter...",modelValue:s.value,inputClass:"text-right",dense:!0,borderless:!0,onInput:e=>{s.value=e}},{append:()=>h(QIcon,{class:"cursor-pointer",name:null!==s.value?"clear":"search",onClick:Q})})}function S(){return h(QToolbar,{},[O(),h("div",{class:"q-ml-md col-auto text-grey text-caption"},[n.screen.gt.xs&&e.type]),h(QSpace),n.screen.width>=385&&I(),T()])}function T(){return h(QIcon,{class:"cursor-pointer text-grey",name:"menu",size:"md"},[h(QMenu,[h("div",{class:"row no-wrap q-pa-md"},[h("div",{class:"column"},[h(QCheckbox,{modelValue:v.value,label:"Show deprecated",directives:[{name:"close-popup"}],onInput:e=>{v.value=e}}),h(QCheckbox,{modelValue:f.value,label:"Show removed",directives:[{name:"close-popup"}],onInput:e=>{f.value=e}})])])])])}function A(){return h("div",{class:"row justify-between items-center no-wrap"+(n.dark.isActive?"":" bg-grey-2 text-grey-7")},[h(QTabs,{class:"col-grow text-caption",modelValue:a.value,dense:!0,activeColor:n.dark.isActive?"yellow":"primary",indicatorColor:n.dark.isActive?"yellow":"primary",align:"left",narrowIndicator:!0,onInput:e=>{a.value=e}},[...Object.keys(l.value).map(e=>h(QTab,{key:e+"-tab",name:e},{default:()=>P(e,l.value[e])}))])])}function P(e,o,n){return h("div",{class:"row no-wrap items-center self-stretch q-pa-xs",style:{minWidth:!0===n?"120px":void 0}},[h("span",{class:"q-mr-xs text-uppercase text-weight-medium"},e),h("div",{class:"col"}),o>0&&h(QBadge,[o])])}function q(){return h(QTabPanels,{modelValue:a.value,animated:!0,onInput:e=>{a.value=e}},[R()])}function R(){return[...Object.keys(l.value).map(e=>h(QTabPanel,{key:e+"-panel",class:"q-pa-none",name:e},["props"===e&&V(e,i.value[e]),"props"!==e&&E(e,i.value[e])]))]}function E(e,o){return h("div",{class:"component-api__container"},[h(JsonApiList,{name:e,json:o})])}function V(e,o){return h("div",{class:"fit row"},[h("div",{class:"col-auto row no-wrap q-py-lg"+(n.dark.isActive?"":" bg-grey-2 text-grey-7")},[h(QTabs,{class:"text-caption"+(n.dark.isActive?"":" bg-grey-2 text-grey-7"),modelValue:r.value,dense:!0,vertical:!0,activeColor:n.dark.isActive?"yellow":"primary",indicatorColor:n.dark.isActive?"yellow":"primary",align:"left",narrowIndicator:!0,onInput:e=>{r.value=e}},[...Object.keys(p).map(e=>h(QTab,{key:e+"-inner-tab",class:"col-shrink",name:e},{default:()=>P(e,p[e],!0)}))])]),h(QSeparator,{vertical:!0,color:m.value,style:{minHeight:"600px"}}),B()])}function B(){return h(QTabPanels,{class:"col",modelValue:r.value,animated:!0,transitionPrev:"slide-down",transitionNext:"slide-up",onInput:e=>{r.value=e}},[L()])}function L(){return[...Object.keys(d).map(e=>h(QTabPanel,{key:e+"-inner-panel",class:"q-pa-none",name:e},[E(e,d[e])]))]}function N(){const n=o.footer;if(!0!==e.noFooter)return h("div",{class:"component-api__footer row justify-between items-center"},[n||h("div","Quasar JSON API Viewer v"+version$1+" - Created and maintained by Jeff Galbraith (@hawkeye64)")])}function J(){return h(QCard,{class:"no-shadow",flat:!0,bordered:!0,style:{border:`${u.value} 1px solid`}},[S(),h(QSeparator,{color:m.value}),A(),h(QSpace),h(QSeparator,{color:m.value}),q(),N()])}function D(){return h("section",{id:_.value,class:"q-pa-md overflow-auto"},[J()])}function $(){return h("div",[D()])}function M(){if(!0===t.value)return $()}return watch(o=>()=>{y(e.json)}),watch(o=>()=>{y(e.json)}),watch(o=>()=>{y(e.json)}),onMounted(()=>{a.value=e.startingTab||a.value,r.value=e.startingInnerTab||r.value,y(e.json)}),()=>M()}});const version="2.0.0-alpha.2";function install(e){e.component(Component.name,Component)}var VuePlugin=Object.freeze({__proto__:null,version:version,Component:Component,install:install});export default VuePlugin;export{Component,install,version};